;; trr: a type-writing training program on GNU Emacs.
;;  Copyright (C) 1992 INAMURA, You
;;     Author:  INAMURA, You (inamura@icot.or.jp)

;;  Copyright (C) 1992 KATO Kenji (kato@ip.cs.oki.co.jp)
;;	Please send suggestions and corrections to the above address.

;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY.  No author or distributor
;; accepts responsibility to anyone for the consequences of using it
;; or for whether it serves any particular purpose or works at all,
;; unless he says so in writing.  Refer to the GNU Emacs General Public
;; License for full details.

;; Everyone is granted permission to copy, modify and redistribute
;; this software, but only under the conditions described in the
;; GNU Emacs General Public License.   A copy of this license is
;; supposed to have been given to you along with this software so you
;; can know your rights and responsibilities.  It should be in a
;; file named COPYING.  Among other things, the copyright notice
;; and this notice must be preserved on all copies.

;; $B%f!<%6%*%W%7%g%s(B
(defvar TRR:trainer-type-face (if (<= 19 (string-to-int emacs-version))
				  'bold)
  "$BF~NO8e$N%F%-%9%H(B face")
(defvar TRR:eval-point-face       nil)
(defvar TRR:eval-point-foreground nil)
(defvar TRR:eval-point-background nil)
(defvar TRR:misstype-bell nil "non-nil $B$J$i!$%_%9%?%$%W;~$K%Y%k$rLD$i$9(B")
(defvar TRR:display-point-in-playing t "non-nil $B$J$i!$<B9TCf$KF@E@I=<((B")
(defvar TRR:directory (concat (getenv "TRRDIR") "/") "TRR $B%G%#%l%/%H%j(B")
(defvar TRR:miss-type-face        nil)
(defvar TRR:demo t "non-nil $B$J$i!$(Btrr $B5/F0;~$K(Bi$B%G%b(B")

(defconst TRR:history-of-trr "\
 Original(Pascal&C) -- $B<i;3(B $B9W(B\n\
 Emacs-Lisp version -- $B0pB<(B $BM:(B\n\
 Author -- $B2CF#8&;y(B, 1992/Nov/20\n\
 Modify -- $B=P1@@5>0(B, 1996/Oct/09\n\
 $B#t#r#r(B Ver.1g")

;; $B3F<o$N%U%!%$%k(B
(defvar   TRR:update-program  (concat TRR:directory "update"))
(defvar   TRR:message-file (concat TRR:directory "trr-message"))
(defvar   TRR:select-text-file (concat TRR:directory "INDEX"))
(defvar   TRR:text-file nil "$B%F%-%9%H%U%!%$%k(B")
(defvar   TRR:record-file nil "$B<B9T7k2L$N%U%!%$%k(B")
(defvar   TRR:score-file nil "$B%9%3%"%U%!%$%k(B")

;; $B3F<o$N%P%C%U%!(B
(defconst TRR:trainer-menu-buffer     "$B%?%$%W!u%a%K%e!<(B")
(defconst TRR:result-buffer           "-----$B7k2L(B-----")
(defconst TRR:data-buffer             "$B@.@SI=<((B")
(defconst TRR:message-buffer          "$B%a%C%;!<%8(B")
(defconst TRR:log-buffer              "$B2a5n$N@.@S(B")
(defconst TRR:graph-buffer            "$B%0%i%U(B")
(defconst TRR:record-buffer           "$B$F$a$'$N<B9T5-O?$5(B")
(defconst TRR:display-buffer          "$B3F<oI=<((B")

;; $B3F<o$N%&%$%s%I%&%3%s%U%#%.%e%l!<%7%g%s(B
(defvar TRR:prev-win-conf    nil  "trr$B$r<B9T$9$kA0$N(Bwin-conf")
(defvar TRR:win-conf         nil  "trr$B$r<B9TCf$N(Bwin-conf")
(defvar TRR:win-conf-typist  nil  "$B%?%$%T%9%HMQ$N(Bwin-conf")
(defvar TRR:win-conf-display nil  "$B3F<oI=<(MQ$N(Bwin-conf")

;; $B3F<o$N%U%i%0(B
(defvar TRR:start-flag        nil "trr$B$,;O$^$C$F$$$k$+$I$&$+(B")
(defvar TRR:quit-flag         nil "trr$B$r=*N;$5$;$k$+$I$&$+(B")
(defvar TRR:update-flag       nil "$B5-O?99?7$7$?$+$I$&$+(B")
(defvar TRR:pass-flag         nil "$B%9%F%C%W$r%Q%9$7$?$+$I$&$+(B")
(defvar TRR:cheat-flag        nil "$B$$$s$A$-$7$?$+$I$&$+(B")
(defvar TRR:beginner-flag     nil "$B=i$a$F(Btrr$B$r$7$?$+$I$&$+(B")
(defvar TRR:random-flag         t "trr$B$r$7$F$$$k$+$I$&$+(B")
(defvar TRR:secret-flag         t "update$B$7$J$$$+$I$&$+(B")
(defvar TRR:typist-flag         t "$B%?%$%T%9%H$rL\;X$9$+$I$&$+(B")
(defvar TRR:small-window-flag nil "$B%&%#%s%I%&$,>.$5$$$+$I$&$+(B")
(defvar TRR:skip-session-flag nil "$B%;%C%7%g%s$r<B9T$7$J$$$+$I$&$+(B")
(defvar TRR:emacs19 (<= 19 (string-to-int emacs-version)))
(defvar TRR:mule (boundp 'MULE))

;; $B%;%C%7%g%sKh$NJQ?t(B
(defvar TRR:eval               -1 "$B:#2s=P$7$?E@?t(B")
(defvar TRR:whole-char-count   0 "$B%F%-%9%H$NJ8;z?t(B")
(defvar TRR:correct-char-count 0 "$B@5$7$/F~NO$7$?J8;z?t(B")
(defvar TRR:start-time         0 "trr(1 session)$B$r=i$a$?;~4V(B")
(defvar TRR:end-time           0 "trr(1 session)$B$r=*$($?;~4V(B")
(defvar TRR:ch                 0 "trr$B<B9TCf$KFI$_9~$s$@%-%c%i%/%?(B")
(defvar TRR:miss-type-ratio    0 "$B%_%9N((B (/1000)")
(defvar TRR:type-speed         0 "$B%?%$%T%s%0B.EY!JJ8;z?t!?J,!K(B")

;; $B%9%F%C%WKh$NJQ?t(B
(defvar TRR:steps                       0 "$B8=:_L\;X$7$F$$$k%9%F%C%W(B")
(defvar TRR:times-of-current-step       0 "$B$3$N%9%F%C%W$G$N<B9T2s?t(B")
(defvar TRR:time-of-current-step        0 "$B$3$N%9%F%C%W$G$N<B9T;~4V(B")
(defvar TRR:whole-chars-of-current-step 0 "$B$3$N%9%F%C%W$G$N<B9T2s?t(B")
(defvar TRR:whole-miss-of-current-step  0 "$B$3$N%9%F%C%W$G$N<B9T;~4V(B")
(defvar TRR:times-for-message                  0 "trr-message.el$B$G;HMQ$9$k(B")

;; $B%0%i%U$r=q$/$?$a$NJQ?t(B
(defvar TRR:skipped-step         0 "$B%9%-%C%W$7$?%9%F%C%W?t(B")
(defvar TRR:list-of-eval       nil "$BK\F|$NF@E@%0%i%UMQ$NJQ?t(B")
(defvar TRR:list-of-speed      nil "$BJ?6QB.EY%0%i%UMQ$NJQ?t(B")
(defvar TRR:list-of-miss       nil "$BJ?6Q%_%9N(%0%i%UMQ$NJQ?t(B")
(defvar TRR:list-of-average    nil "$BJ?6QF@E@%0%i%UMQ$NJQ?t(B")
(defvar TRR:list-of-time       nil "$B<B9T;~4V%0%i%UMQ$NJQ?t(B")
(defvar TRR:list-of-times      nil "$B<B9T2s?t%0%i%UMQ$NJQ?t(B")
(defvar TRR:list-of-value      nil "$BFMGKE@?t%0%i%UMQ$NJQ?t(B")

;; $B$=$NB>$NJQ?t(B
(defvar TRR:contents-text-read-lines 32 "$B%F%-%9%H$NFI$_9~$_9T?t(B")
(defvar TRR:number-of-text-lines 0 "$B%F%-%9%H$N9T?t(B - TRR:contents-text-read-lines")
(defvar TRR:text-lines           0 "$BI=<($9$Y$-%F%-%9%H$N9T?t(B")
(defvar TRR:total-times          0 "$B:#$^$G$N<B9T2s?t(B")
(defvar TRR:total-time           0 "$B:#$^$G$N<B9T;~4V(B")
(defvar TRR:high-score           -1 "$B:#2s$^$G$N:G9bF@E@(B")
(defvar TRR:high-score-old       -1 "$BA02s$^$G$N:G9bF@E@(B")
(defvar TRR:elapsed-time         0)
(defvar TRR:overlay-list         nil "$B;HMQCf$N(B overlay")
(defvar TRR:eval-point-face-overlay nil)
(defvar TRR:miss-type-face-overlays nil)

;;; $B<+F0%m!<%I4X?t(B
(autoload 'TRR:print-first-message-as-result TRR:message-file "" nil)

(if (or TRR:miss-type-face (not TRR:emacs19))
    nil
  (setq TRR:miss-type-face 'TRR:miss-type-face)
  (copy-face 'default TRR:miss-type-face)
  (set-face-foreground TRR:miss-type-face "white")
  (set-face-background TRR:miss-type-face "red"))

;;; $BF@E@$NI>2A4X?t(B
;;; $B!JBGJ8;z?t!]!J8mBG?t!v#1#0!K!K!v#6#0!?!JIC?t!K(B  $B0lHL$N?M(B
;;; $B!JBGJ8;z?t!]!J8mBG?t!v#5#0!K!K!v#6#0!?!JIC?t!K(B  $B%?%$%T%9%H$rL\;X$9?M(B
(defun TRR:evaluate-point (whole miss time)
  (if TRR:typist-flag
      (max 0 (if (zerop time) 0 (/ (* (- whole (* miss 50)) 60) time)))
    (max 0 (if (zerop time) 0 (/ (* (- whole (* miss 10)) 60) time)))))


(defun trr ()
  (interactive)
  (setq TRR:prev-win-conf (current-window-configuration))
  (delete-other-windows)
  (if (or (< (window-height) 20) (< (window-width) 60))
      (progn
	(set-window-configuration TRR:prev-win-conf)
	(error "$B%&%#%s%I%&$,>.$5$9$.$k$o!#(B")))
  (setq TRR:skip-session-flag nil)
  (TRR:start)
  (unwind-protect
      (condition-case nil
	  (trr-main-loop)
	(quit nil))
    (TRR:finish)))


(defun trr-main-loop ()
  (while (TRR:play-p)
    (set-window-configuration TRR:win-conf)
    (if TRR:skip-session-flag
	(progn
	  (setq TRR:start-flag t)
	  (setq TRR:skip-session-flag nil)
	  (set-window-configuration TRR:win-conf-display)
	  (set-buffer (get-buffer-create TRR:display-buffer))
	  (TRR:print-log-for-display))
      (TRR:one-session)
      (if (= TRR:ch 3)			
	  (progn
	    (set-buffer TRR:message-buffer)
	    (erase-buffer))
	(TRR:update-variables)
	(TRR:display-variables-message-graph)
	(if (and TRR:update-flag (not TRR:secret-flag))
	    (TRR:update-score-file TRR:eval))
	))))


(defun TRR:play-p ()
  (and (not TRR:quit-flag)
       (if (not TRR:start-flag)
	   (progn (TRR:select-text)
		  (not TRR:quit-flag))
	 (TRR:select-menu)
	 (not TRR:quit-flag))))


(defun TRR:get-answer (string1 string2 max)
  (let ((answer (string-to-int (read-string string1))))
    (while (or (<= answer 0) (> answer max))
      (setq answer (string-to-int (read-string string2))))
    answer))


(defun TRR:select-text ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (insert-file TRR:select-text-file)
  (untabify (point-min) (point-max))
  (goto-char (point-min))
  (while (looking-at "[ \t]*[#\n]")
    (kill-line 1)) ; remove comment or empty line
  (let ((num 1) max-num)
    (while (not (eobp))
      (insert (format "%4d. " num))
      (or (re-search-forward "[^ \n]+ +[^ \n]+" nil t)
	  (error "%s is corrupt." TRR:select-text-file))
      (kill-line)
      (forward-line 1)
      (while (looking-at "[ \t]*[#\n]")
	(kill-line 1)) ; remove comment or empty line
      (setq num (1+ num)))
    (setq max-num num)
    (goto-char (point-min))
    (insert (TRR:current-trr) "$B8~$1%?%$%W%H%l!<%J!<!'(B\n\n$B%F%-%9%H$NA*Br!'(B\n")
    (end-of-buffer)
    (insert "\n$B3F<o$N@_Dj!'(B\n  97. trr$B$N=*N;(B\n  98. $B@_DjCM$NJQ99(B\n")
    (if (not TRR:skip-session-flag)
	(insert "  99. $B%F%-%9%HA*Br8e%a%K%e!<2hLL$K0\9T(B\n")
      (insert "\n$B%F%-%9%HA*Br8e%a%K%e!<2hLL$K0\9T(B"))
    (goto-char (point-min))
    (setq num (TRR:get-answer "$B$I$l$K$9$k!)(B " "$B$O$C$-$j$7$J$5$$!*(B" 99))
    (if (and (or (< num 0) (> num max-num))
	     (/= num 97)
	     (/= num 98)
	     (/= num 99))
	(setq num (TRR:get-answer "$B$b$&0lEYA*$s$G(B "
				  "$B%F%-%9%H$7$+A*$Y$J$$$o(B "
				  max-num)))
    (cond
     ((= num 97) (setq TRR:quit-flag t))
     ((= num 98) (TRR:change-flag))
     ((= num 99) 
      (setq TRR:skip-session-flag t)
      (TRR:select-text))
     (t
      (TRR:decide-trr-text num)
      (TRR:initiate-files)
      (TRR:initiate-variables)
      (TRR:print-log)
      (TRR:print-data)
      (bury-buffer)
      (set-window-configuration TRR:win-conf)))))


(defun TRR:change-flag ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (let (num)
    (insert "\
$B<!$NCf$+$iA*$s$G2<$5$$!#(B\n\
\n\
1. $B=i5i<T8~$1$N%?%$%W%H%l!<%J(B\n\
   $BI>2A4X?t$O!JBGJ8;z?t!]!J8mBG?t!v#1#0!K!K!v#6#0!?!JIC?t!K(B\n\
   $B%F%-%9%H$O%9%F%C%WKh$KF1$8$b$N$rI=<((B\n\
\n\
2. $BCf5i<T8~$1$N%?%$%W%H%l!<%J!J%G%U%)!<%k%H$O$3$l$K@_Dj$5$l$k!K(B\n\
   $BI>2A4X?t$O!JBGJ8;z?t!]!J8mBG?t!v#1#0!K!K!v#6#0!?!JIC?t!K(B\n\
\n\
3. $B>e5i<T8~$1$N%?%$%W%H%l!<%J(B\n\
   $BI>2A4X?t$O!JBGJ8;z?t!]!J8mBG?t!v#5#0!K!K!v#6#0!?!JIC?t!K(B\n\
   $B#12s$N<B9T$GI,MW$J%?%$%WNL$,B?$$(B\n\
\n\
4. $BHkL)<g5A<T8~$1$N%?%$%W%H%l!<%J(B\n\
   $B=i5i<T8~$1$N%?%$%W%H%l!<%J$HF1$8$G$"$k$,!"(B\n\
   $B%O%$%9%3%"$NEPO?$r9T$J$o$J$$(B\n")
  (setq num (TRR:get-answer "$B$I$l$K$9$k!)(B " "$B$$$C$?$$$I$l$K$9$k$N!)(B " 4))
  (cond
   ((= num 1)
    (setq TRR:random-flag nil)
    (setq TRR:typist-flag nil)
    (setq TRR:secret-flag nil))
   ((= num 2)
    (setq TRR:random-flag t)
    (setq TRR:typist-flag nil)
    (setq TRR:secret-flag nil))
   ((= num 3)
    (setq TRR:random-flag t)
    (setq TRR:typist-flag t)
    (setq TRR:secret-flag nil))
   ((= num 4)
    (setq TRR:random-flag nil)
    (setq TRR:typist-flag nil)
    (setq TRR:secret-flag t))))
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (let* ((height (- (window-height) 5))
	 (text-buffer-height (1+ (- (/ height 2) (% (/ height 2) 3)))))
    (if TRR:typist-flag
	(setq TRR:text-lines (/ (1- (window-height)) 3))
      (setq TRR:text-lines (/ (1- text-buffer-height) 3))))
  (TRR:select-text))



(defun TRR:select-menu ()
  (set-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (insert "\
 1. $B=*N;(B               2. $B<B9T(B                3. $B%O%$%9%3%"(B\n\
 4. $BJ?6QB.EY%0%i%U(B     5. $BJ?6Q%_%9N(%0%i%U(B    6. $BJ?6QF@E@%0%i%U(B\n\
 7. $B<B9T;~4V%0%i%U(B     8. $B<B9T2s?t%0%i%U(B      9. $BFMGKE@?t%0%i%U(B\n\
10. $B2a5n$N@.@S(B        11. $B%F%-%9%H$NJQ99(B     12. $B@_Dj$NJQ99(B\
")
  (let ((num (TRR:get-answer "$B$I$&$9$k$N!)(B " "$B$O$C$-$j$7$J$5$$!*(B" 12)))
    (cond
     ((= num 1)
      (if (not (y-or-n-p "$B=*N;$7$^$9$+!)(B "))
	  (TRR:select-menu)
	(setq TRR:quit-flag t)
	nil))
     ((= num 2)
      (TRR:read-file TRR:text-file) ;  $B<!$N%F%-%9%H$rFI$`(B
      t)
     ((= num 3)
      (set-window-configuration TRR:win-conf-display)
      (TRR:show-ranking)
      (TRR:select-menu))
     ((= num 4)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-speed TRR:skipped-step
		       "$B%9%F%C%W!]J?6Q%9%T!<%I!JJ8;z!?J,!K%0%i%U(B")
      (TRR:select-menu))
     ((= num 5)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-miss TRR:skipped-step
		       "$B%9%F%C%W!]J?6Q%_%9N(!J(B/1000$B!K%0%i%U(B")
      (TRR:select-menu))
     ((= num 6)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-average TRR:skipped-step
		       "$B%9%F%C%W!]J?6QF@E@%0%i%U(B")
      (TRR:select-menu))
     ((= num 7)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-time TRR:skipped-step
		       "$B%9%F%C%W!]<B9T;~4V!JJ,!K%0%i%U(B")
      (TRR:select-menu))
     ((= num 8)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-times TRR:skipped-step
		       "$B%9%F%C%W!]<B9T2s?t%0%i%U(B")
      (TRR:select-menu))
     ((= num 9)
      (set-window-configuration TRR:win-conf-display)
      (set-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-value TRR:skipped-step
		       "$B%9%F%C%W!]FMGKE@?t%0%i%U(B")
      (TRR:select-menu))
     ((= num 10)
      (set-window-configuration TRR:win-conf-display)
      (set-buffer (get-buffer-create TRR:display-buffer))
      (TRR:print-log-for-display)
      (TRR:select-menu))
     ((= num 11)
      (TRR:save-file TRR:record-buffer TRR:record-file)
      (TRR:kill-file TRR:record-file)
      (TRR:kill-file TRR:score-file)
      (TRR:kill-file TRR:text-file)
      (TRR:select-text)
      (not TRR:quit-flag))
     ((= num 12)
      (TRR:save-file TRR:record-buffer TRR:record-file)
      (TRR:kill-file TRR:record-file)
      (TRR:kill-file TRR:score-file)
      (TRR:kill-file TRR:text-file)
      (TRR:change-flag)
      (not TRR:quit-flag))
     )))


(defun TRR:initiate-files ()
  (save-excursion
    (if (file-exists-p TRR:score-file)
	nil
      (write-region 1 1 TRR:score-file) ;make a empty file
      (set-file-modes TRR:score-file ?\666))
    (if (null (get-file-buffer TRR:score-file))
	(setq TRR:score-file (buffer-file-name (find-file-noselect TRR:score-file))))
    (if (null (get-file-buffer TRR:text-file))
	(setq TRR:text-file (buffer-file-name (find-file-noselect TRR:text-file))))
    (set-buffer (get-buffer-create TRR:record-buffer))
    (erase-buffer)
    (if (file-exists-p TRR:record-file)
	(insert-file TRR:record-file)
      (insert "  0    0      0      0     0 $B$U$!$$$H(B!\n"))))


(defun TRR:cheat-p ()
  (setq TRR:cheat-flag
	(or 
	 (if TRR:typist-flag
	     (< TRR:whole-char-count 480)
	   (< TRR:whole-char-count 160))
	 (and (> (- TRR:eval TRR:high-score) 100)
	      (not (< TRR:high-score 0))
	      (not (< TRR:total-times 3))
	      (not TRR:typist-flag))
	 (> TRR:eval 750))))


(defun TRR:goto-decide-text-line (num)
  (goto-char (point-min))
  (while (looking-at "[ \t]*[#\n]") (forward-line))
  (while (< 1 num)
    (setq num (1- num))
    (forward-line)
    (while (looking-at "[ \t]*[#\n]") (forward-line))))


(defun TRR:decide-trr-text (num)
  (switch-to-buffer 
   (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (insert-file TRR:select-text-file)
  (untabify (point-min) (point-max))
  (TRR:goto-decide-text-line num)
  (or (looking-at "[^ \n]+ +[^ \n]+ +\\([^ \n]+\\) +\\([^ \n]+\\)")
      (error "%s is corrupt." TRR:select-text-file))
  (setq temp-file (buffer-substring (match-beginning 1) (match-end 1)))
  (setq temp-id	(buffer-substring (match-beginning 2) (match-end 2)))
  (setq	TRR:text-file
	(expand-file-name (concat TRR:directory
				  "text/"
				  temp-file))
	TRR:record-file
	(expand-file-name (concat TRR:directory
				  "record/"
				  (user-login-name)
				  "-"
				  temp-id
				  (TRR:file-string)))
	TRR:score-file
	(expand-file-name (concat TRR:directory
				  "record/SCORES-"
				  temp-id
				  (TRR:file-string)))))

(defun TRR:file-string ()
  (cond
   (TRR:secret-flag "-easy")
   (TRR:typist-flag "-typist")
   ((not TRR:random-flag) "-easy")
   (t "")))


(defun TRR:prepare-buffers ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (if TRR:demo
      (TRR:demo))
  (split-window (get-buffer-window (current-buffer)) 5)
  (other-window 1)
  (switch-to-buffer (get-buffer-create TRR:display-buffer))
  (setq TRR:win-conf-display (current-window-configuration))
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (setq TRR:win-conf-typist (current-window-configuration))
  (let* ((height (- (window-height) 5))
	 (text-buffer-height (1+ (- (/ height 2) (% (/ height 2) 3)))))
    (if TRR:typist-flag
	(setq TRR:text-lines (/ (1- (window-height)) 3))
      (setq TRR:text-lines (/ (1- text-buffer-height) 3))
      (if (< TRR:text-lines 3)
	  (progn
	    (setq TRR:small-window-flag t)
	    (setq TRR:text-lines (/ (1- (window-height)) 3)))
	(setq TRR:small-window-flag nil)))
    (set-buffer (get-buffer-create TRR:trainer-menu-buffer))
    (switch-to-buffer TRR:trainer-menu-buffer)
    (split-window (get-buffer-window (current-buffer))
		  text-buffer-height)
    (set-buffer (get-buffer-create TRR:result-buffer))
    (erase-buffer)
    (TRR:print-first-message-as-result)
    (switch-to-buffer-other-window TRR:result-buffer)
    (split-window (get-buffer-window (current-buffer)) 5)
    (split-window-horizontally 24)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:data-buffer))
    (TRR:print-data)
    (split-window-horizontally 20)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:message-buffer))
    (delete-region (point-min) (point-max))
    (insert TRR:history-of-trr)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:log-buffer))
    (split-window-horizontally 32)
    (TRR:print-log)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:graph-buffer))
    (TRR:write-graph TRR:list-of-eval 0 "$B:#F|$NF@E@%0%i%U(B")
    (recenter -1)
    (other-window 1)
    (setq TRR:win-conf (current-window-configuration))))


(defun TRR:start ()
  (message "$B$A$g$C$HBT$C$F(B...")
  (setq TRR:secret-flag nil)
  (setq TRR:random-flag t)
  (setq TRR:typist-flag nil)
  (setq TRR:start-flag nil)
  (setq TRR:quit-flag nil)
  (TRR:prepare-buffers)
  (TRR:move-down 1)
  (TRR:move-up 1))


(defun TRR:kill-buffer (buffer)
  (let ((tb (get-buffer buffer)))
    (if tb (kill-buffer tb))))

(defun TRR:kill-file (file)
  (if file
      (let ((tfile (get-file-buffer (expand-file-name file))))
	(if tfile (kill-buffer tfile)))))

(defun TRR:save-file (buffer file)
  (let ((tb (get-buffer buffer))
	tfile)
    (if tb
	(save-excursion
	  (set-buffer (get-buffer-create buffer))
	  (if (not (buffer-modified-p)) nil
	    (write-region (point-min) (point-max) file))))))

(defun TRR:finish ()
  (and TRR:emacs19
       TRR:eval-point-face-overlay
       (delete-overlay TRR:eval-point-face-overlay))
  (setq TRR:eval-point-face-overlay nil)
  (TRR:delete-overlay)
  (TRR:kill-buffer TRR:trainer-menu-buffer)
  (TRR:kill-buffer TRR:result-buffer)
  (TRR:kill-buffer TRR:graph-buffer)
  (TRR:kill-buffer TRR:message-buffer)
  (TRR:kill-buffer TRR:data-buffer)
  (TRR:kill-buffer TRR:log-buffer)
  (TRR:kill-buffer TRR:display-buffer)
  (TRR:save-file TRR:record-buffer TRR:record-file)
  (TRR:kill-file TRR:record-file)
  (TRR:kill-file TRR:score-file)
  (TRR:kill-file TRR:text-file)
  (TRR:kill-buffer TRR:record-buffer)
  (TRR:kill-file TRR:record-file)
  (set-window-configuration TRR:prev-win-conf)
  (message "$B$^$?2q$&F|$^$G(B...."))


(defun TRR:one-session ()
  (other-window -1)
  (TRR:write-graph TRR:list-of-eval 0 "$B:#F|$NF@E@%0%i%U(B")
  (other-window -1)
  (TRR:print-log)
  (other-window 2)
  (if (or TRR:typist-flag TRR:small-window-flag)
      (set-window-configuration TRR:win-conf-typist))
  (erase-buffer)
  (save-excursion
    (set-buffer TRR:display-buffer)
    (setq TRR:start-flag t)
    (copy-to-buffer TRR:trainer-menu-buffer
		    (point)
		    (progn
		      (forward-line (* 3 TRR:text-lines))
		      (point))))
  (goto-char (point-min))
  (forward-line 1)
  (setq TRR:correct-char-count 0)
  (setq TRR:whole-char-count 0)
  (if (eobp) t
    (let ((inhibit-quit t)
	  (truncate-lines t)
	  (lines (/ (count-lines (point-min) (point-max)) 3))
	  (text-pos (save-excursion (forward-line -1) (point))))
      (if TRR:emacs19
	  (progn
	    (or buffer-display-table
		(setq buffer-display-table (make-display-table)))
	    (aset buffer-display-table ?\t (vconcat "^I"))))
      (message "C-c for quit")
      (TRR:new-overlay text-pos)
      (setq TRR:start-time nil)
      (setq TRR:ch (TRR:read-char))
      (setq TRR:start-time (TRR:lap-time))
      (while (and (> lines 0)
		  (/= TRR:ch ?\C-c))   ;; if TRR:ch = ^C then quit
	(setq TRR:whole-char-count (1+ TRR:whole-char-count))
	(if (= TRR:ch (char-after text-pos))

	    ;; Correct
	    (progn
	      (setq TRR:correct-char-count (1+ TRR:correct-char-count))
	      (setq text-pos (1+ text-pos))
	      (TRR:insert-char TRR:ch)
	      (TRR:move-overlay text-pos)
	      (if (= TRR:ch ?\r)
		  (progn
		    (if (/= (following-char) ?\n) (kill-line))
		    (setq lines (1- lines))
		    (forward-line 2)
		    (setq text-pos (point))
		    (TRR:new-overlay text-pos)
		    (forward-line 1)))
	      (if (> lines 0)
		  (setq TRR:ch (TRR:read-char))))

	  ;; Miss type
	  (TRR:mark-miss-type-position text-pos)
	  (save-excursion
	    (TRR:move-down 1)
	    (insert "^"))
	  (while (and (/= TRR:ch (char-after text-pos))
		      (/= TRR:ch  ?\C-c))
	    (if TRR:misstype-bell (ding))
	    (TRR:insert-char TRR:ch)
	    (backward-char 1)
	    (setq TRR:ch (TRR:read-char))
	    (delete-char 1))
	  (setq text-pos (1+ text-pos))
	  (TRR:new-overlay text-pos)
	  (TRR:insert-char TRR:ch)
	  (cond ((= TRR:ch ?\r)
		 (if (and (not (eobp)) (/= (following-char) ?\n))
		     (kill-line))
		 (setq lines (1- lines))
		 (forward-line 2)
		 (setq text-pos (point))
		 (TRR:new-overlay text-pos)
		 (forward-line 1)
		 (if (> lines 0)
		     (setq TRR:ch (TRR:read-char))))
		((= TRR:ch ?\C-c)
		 (setq lines 0))
		((> lines 0)
		 (setq TRR:ch (TRR:read-char))))))

      ;; Done
      (setq TRR:end-time (TRR:lap-time))))
  (if (or TRR:typist-flag TRR:small-window-flag)
      (set-window-configuration TRR:win-conf)))


(defun TRR:finish-one-session ()
  (set-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (goto-char (point-min))
  (message "Please type the any key")
  (TRR:read-char0)
  (if TRR:emacs19
      (progn
	(mapcar (function delete-overlay) TRR:miss-type-face-overlays)
	(TRR:delete-overlay))))


(defun TRR:add-stroke-char-list (ch)
  (let ((pos (point))
	(p   (- (window-width) 3)))
    (setq TRR:stroke-char-list
	  (append TRR:stroke-char-list (list (cons pos p))))
    (save-excursion
      (end-of-line)
      (let ((c (current-column)))
	(if (< c p)
	    (insert-char ?\  (- p c 1))
	  (backward-delete-char 1)))
      (insert-char ch 1))))


(defun TRR:read-char0 (&optional nonblock)
  (let ((ch
	 (if (not nonblock)
	     (if TRR:emacs19 (read-char-exclusive) (read-char))
	   (if (sit-for 0)
	       nil  ; no input
	     ((lambda (e)
		(if (and (integerp e) (<= 0 e) (<= e 127))
		    e
		  (if (eq e 'return)
		      ?\r
		    nil)))
	      (if TRR:emacs19 (read-char-exclusive) (read-char)))))))
    (if (and inhibit-quit quit-flag)
	(setq quit-flag nil
	      ch ?\C-g))
    ch))


(defun TRR:insert-eval-point (eval)
  (let (start end)
    (if (not TRR:emacs19)
	(insert (int-to-string eval))
      (setq start (point))
      (insert (int-to-string eval))
      (setq end (point))
      (if TRR:eval-point-face-overlay
	  (move-overlay TRR:eval-point-face-overlay start end)
	(setq TRR:eval-point-face-overlay (make-overlay start end))
	(if TRR:eval-point-face
	    (if (not (eq TRR:eval-point-face 'TRR:eval-point-face))
		(copy-face TRR:eval-point-face 'TRR:eval-point-face))
	  (setq TRR:eval-point-face 'TRR:eval-point-face)
	  (copy-face 'default TRR:eval-point-face))
	(overlay-put TRR:eval-point-face-overlay 'face 'TRR:eval-point-face)
	(and TRR:eval-point-foreground
	     (set-face-foreground 'TRR:eval-point-face
				  TRR:eval-point-foreground))
	(and TRR:eval-point-background
	     (set-face-background 'TRR:eval-point-face
				  TRR:eval-point-background))))))


(defun TRR:read-char1 ()
  (let (ch eval d err1 err2)
    (if (= (following-char) ?\n)
	(save-excursion  (insert-char ?\  1)))
    (while (progn
	     (save-excursion
	       (setq eval (TRR:evaluate-point
			   TRR:whole-char-count
			   (- TRR:whole-char-count TRR:correct-char-count)
			   (TRR:time-different TRR:start-time
					       (TRR:lap-time))))
	       (setq d (- TRR:whole-char-count TRR:correct-char-count))
	       (if (zerop TRR:whole-char-count)
		   (setq err1 0 err2 0)
		 (setq err1 (/ (* 100 d) TRR:whole-char-count)
		       err2 (% (/ (* 1000 d) TRR:whole-char-count) 10)))
	       (if (eobp)
		   nil
		 (forward-char 1)
		 (if (/= (following-char) ?\n)
		     (kill-line)))
	       (insert-char ?\  1)
	       (TRR:insert-eval-point eval)
	       (insert (format " (%d.%d%% miss)" err1 err2)))
	     (sit-for 1)
	     (not (setq ch (TRR:read-char0 t)))))
    ch))


(defun TRR:read-char ()
  (if (and TRR:start-time TRR:display-point-in-playing)
      (let ((echo-keystrokes 0)
	    ch)
	(while (progn
		 (setq ch (TRR:read-char1))
		 (cond ((= ch ?\C-l)
			(recenter)
			t)   ; continue
		       ((= ch ?\C-j)
			(setq ch ?\r)
			nil) ; break
		       (t
			nil)))) ; break
	ch)
    (TRR:read-char0)))


(defun TRR:insert-char (ch)
  (insert-char ch 1))

	
(defun TRR:move-to-column (col)
  (let ((c (move-to-column col)))
    (if (< c col)
	(insert-char ?\  (- col c)))))


(defun TRR:move-down (&optional n)
  (let ((c (current-column)))
    (forward-line n)
    (TRR:move-to-column c)))


(defun TRR:move-up (&optional n)
  (let ((c (current-column)))
    (forward-line (- n))
    (TRR:move-to-column c)))


(defun TRR:time-different (start end)
  (if TRR:emacs19
      (truncate (- end start))
    ((lambda (x)
       (if (>= x 0)
	   x
	 (+ x 86400)))
     (- end start))))


(defun TRR:update-variables ()
  (setq TRR:quit-flag nil)
  (setq TRR:elapsed-time (TRR:time-different TRR:start-time TRR:end-time))
  (setq TRR:eval
	(TRR:evaluate-point TRR:whole-char-count
			    (- TRR:whole-char-count TRR:correct-char-count)
			    TRR:elapsed-time))
  (setq TRR:list-of-eval (cons TRR:eval TRR:list-of-eval))
  (setq TRR:pass-flag
	(and (>= TRR:eval (* 10 (1+ TRR:steps)))
	     (not (TRR:cheat-p))))
  (setq TRR:update-flag
	(and (or (> TRR:eval TRR:high-score)
		 (< TRR:high-score-old 0))
	     (not (TRR:cheat-p))))
  (setq TRR:beginner-flag (< TRR:high-score-old 0))
  (if TRR:cheat-flag nil
    (setq TRR:total-time (+ TRR:total-time TRR:elapsed-time))
    (setq TRR:total-times (1+ TRR:total-times))
    (setq TRR:time-of-current-step 
	  (+ TRR:time-of-current-step TRR:elapsed-time))
    (setq TRR:times-of-current-step (1+ TRR:times-of-current-step))
    (setq TRR:whole-chars-of-current-step
	  (+ TRR:whole-char-count TRR:whole-chars-of-current-step))
    (setq TRR:whole-miss-of-current-step
	  (+ (- TRR:whole-char-count TRR:correct-char-count)
	     TRR:whole-miss-of-current-step)))
  (TRR:write-current-data)
  (if TRR:pass-flag
      (progn 
	(setq TRR:times-for-message TRR:times-of-current-step)
	(setq TRR:time-of-current-step 0)
	(setq TRR:times-of-current-step 0)
	(setq TRR:whole-chars-of-current-step 0)
	(setq TRR:whole-miss-of-current-step 0)
	(if TRR:beginner-flag
	    (setq TRR:steps (/ TRR:eval 10))
	  (setq TRR:steps (1+ TRR:steps)))))
  (if TRR:update-flag
      (progn
	(setq TRR:high-score-old TRR:high-score)
	(setq TRR:high-score TRR:eval)))
  (if (< TRR:high-score-old 0) (setq TRR:high-score-old TRR:eval))
  (let (diff)
    (setq diff (- TRR:whole-char-count TRR:correct-char-count))
    (setq TRR:miss-type-ratio (/ (* 1000 diff) TRR:whole-char-count)))
  (setq TRR:type-speed (/ (* TRR:whole-char-count 60) TRR:elapsed-time)))


(defun TRR:display-variables-message-graph ()
  (other-window 1)
  (TRR:print-result)
  (other-window 1)
  (TRR:print-data)
  (other-window 1)
  (TRR:print-message)
  (other-window 1)
  (TRR:print-log)
  (other-window 1)
  (TRR:write-graph TRR:list-of-eval 0 "$B:#F|$NF@E@%0%i%U(B")
  (other-window 1)
  (TRR:finish-one-session))


(defun TRR:print-result ()
  (erase-buffer)
  (insert
   (format "\
 $B=jMW;~4V!'(B%4d $BIC(B\n\
  $B%_%9N((B $B!'(B%2d.%1d %%\n\
 $B;z?t!?J,!'(B%4d\n\
  $BI>(B  $B2A(B $B!'(B%4d %s"
	   TRR:elapsed-time
	   (/ TRR:miss-type-ratio 10)
	   (% TRR:miss-type-ratio 10)
	   TRR:type-speed
	   TRR:eval
	   (if TRR:pass-flag " Pass" "Retry"))))


(defun TRR:print-data ()
  (save-excursion
    (switch-to-buffer (get-buffer-create TRR:data-buffer))
    (erase-buffer)
    (insert 
     (format "\
 $B%9%F%C%W!'(B%5d\n\
  $BL\(B  $BI8(B $B!'(B%5d$BE@(B\n\
 $B:G9b5-O?!'(B%5d$BE@(B\n\
  trr$B2s?t!'(B%5d$B2s(B"
	     (1+ TRR:steps) 
	     (* (1+ TRR:steps) 10)
	     (if (< TRR:high-score 0) 0 TRR:high-score)
	     TRR:total-times))))
  

(defun TRR:print-log ()
  (save-excursion
    (let ((logb (get-buffer-create TRR:log-buffer))
	  (recb (get-buffer-create TRR:record-buffer))
	  (curstep 1)
	  curtimes curtime curpoint curmiss curspeed wc mc curdate)
      (set-buffer logb)
      (erase-buffer)
      (set-buffer recb)
      (goto-char (point-min))
      (while (not (eobp))
	(setq curpoint (point))
	(setq wc (string-to-int
			  (buffer-substring 
			   (+ curpoint 16) (+ curpoint 22))))
	(if (zerop wc)
	    nil
	  (setq curtimes (string-to-int
			  (buffer-substring
			   (+ curpoint 4) (+ curpoint  8))))
	  (setq curtime (string-to-int
			 (buffer-substring 
			  (+ curpoint 9) (+ curpoint 15))))
	  (setq mc (string-to-int
		    (buffer-substring 
		     (+ curpoint 23) (+ curpoint 28))))
	  (setq curmiss
		(if (zerop wc) 0 (/ (* mc 1000) wc)))
	  (setq curspeed
		(if (zerop curtime) 0 (/ (* wc 60) curtime)))
	  (setq curdate
		(if (boundp 'MULE)
		    (save-excursion
		      (goto-char (+ curpoint 29))
		      (looking-at ".*")
		      (buffer-substring (match-beginning 0)
					(match-end 0)))
		  (buffer-substring (+ curpoint 29) (+ curpoint 38))))
	  (set-buffer logb)
	  (insert (format "%2d:%4d%4d%5d%4d %s\n" 
			  curstep
			  curtimes
			  (/ curtime 60)
			  curspeed
			  curmiss
			  curdate)))
	(setq curstep (+ curstep 1))
	(set-buffer recb)
	(forward-line)) ; end of while
      (set-buffer logb)
      (forward-line (- 3 (window-height)))
      (delete-region (point-min) (point))
      (insert (TRR:current-trr) "$B8~$1%?%$%W%H%l!<%J(B\n")
      (insert "step $B2s(B  $BJ,(B   $BB.(B  $BN((B   $BFMGKF|(B\n"))))


(defun TRR:print-log-for-display ()
  (save-excursion
    (switch-to-buffer (get-buffer-create TRR:display-buffer))
    (erase-buffer)
    (let (curstep curtimes curtime curpoint passpoint
		  avepoint curmiss curspeed wc mc curdate)
      (switch-to-buffer (get-buffer-create TRR:record-buffer))
      (goto-char (point-min))
      (setq curstep 1)
      (while (not (eobp))
	(setq curpoint (point))
	(setq passpoint (string-to-int 
			   (buffer-substring
			    curpoint (+ curpoint 3))))
	(setq curtimes (string-to-int 
			   (buffer-substring
			    (+ curpoint 4) (+ curpoint  8))))
	(setq curtime (string-to-int 
			  (buffer-substring 
			   (+ curpoint 9) (+ curpoint 15))))
	(setq wc (string-to-int 
			  (buffer-substring 
			   (+ curpoint 16) (+ curpoint 22))))
	(setq mc (string-to-int 
			  (buffer-substring 
			   (+ curpoint 23) (+ curpoint 28))))
	(setq curmiss 
	      (if (zerop wc) 0 (/ (* mc 1000) wc)))
	(setq curspeed 
	      (if (zerop curtime) 0 (/ (* wc 60) curtime)))
	(setq avepoint (if (zerop curtime) 0 
			 (TRR:evaluate-point wc mc curtime)))
	(setq curdate
	      (if (boundp 'MULE)
		  (save-excursion
		    (goto-char (+ curpoint 29))
		    (looking-at ".*")
		    (buffer-substring (match-beginning 0)
				      (match-end 0)))
		(buffer-substring (+ curpoint 29) (+ curpoint 38))))
	(forward-line)
	(switch-to-buffer (get-buffer-create TRR:display-buffer))
	(if (/= wc 0)
	    (insert (format "\
 %2d:  %3d$B2s(B  %3d$BJ,(B  %4d$B;z(B/$BJ,(B  %3d.%d%%  %4d$BE@(B   %s   %d\n" 
			    curstep
			    curtimes
			    (/ curtime 60)
			    curspeed
			    (/ curmiss 10)
			    (% curmiss 10)
			    avepoint
			    curdate
			    passpoint)))
	(setq curstep (+ curstep 1))
	(switch-to-buffer (get-buffer-create TRR:record-buffer))))
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (if TRR:emacs19
	  (forward-line (- 6 (window-height)))
	(previous-line (- (window-height) 6)))
      (delete-region (point-min) (point))
      (insert 
       (format "\
$B:G9b5-O?!'(B%d$BE@(B,   $BAm<B9T2s?t!'(B%d$B2s(B,   $BAm<B9T;~4V!'(B%d$BJ,(B\n"
	       (if (< TRR:high-score 0) 0 TRR:high-score)
	       TRR:total-times
	       (/ TRR:total-time 60)))
      (insert "\n\
step   $B<B9T(B   $B<B9T(B     $BJ?6Q(B     $BJ?6Q(B     $BJ?6Q(B     $BFMGKF|(B   $BFMGK(B\n\
       $B2s?t(B   $B;~4V(B   $BF~NOB.EY(B  $B%_%9N((B    $BF@E@(B              $BF@E@(B\n\
---------------------------------------------------------------\n")))


(defun TRR:current-trr ()
  (cond
   (TRR:typist-flag "$B>e5i<T(B")
   (TRR:secret-flag "$BHkL)<g5A<T(B")
   (TRR:random-flag "$BCf5i<T(B")
   (t               "$B=i5i<T(B")))

(defun TRR:write-current-data ()
  (save-excursion
    (set-buffer (get-buffer-create TRR:record-buffer))
    (if TRR:beginner-flag
	(let ((count (1- (/ TRR:eval 10))))
	  (while (> count 0)
	    (insert "  0    0      0      0     0 $B$U$!$$$H(B!\n")
	    (setq count (1- count)))))
    (goto-char (point-max))
    (forward-line -1)
    (beginning-of-line)
    (delete-region (point) (point-max))
    (insert (format "%3d %4d %6d %6d %5d %s\n"
		    TRR:eval
		    TRR:times-of-current-step
		    TRR:time-of-current-step
		    TRR:whole-chars-of-current-step
		    TRR:whole-miss-of-current-step
		    (TRR:get-date)))
    (if TRR:pass-flag
	(insert "  0    0      0      0     0 $B$U$!$$$H(B!\n"))))


(defun TRR:convert-time-string-to-second (st)
  (let ((hr  (string-to-int (substring st 11 13))) ; $B2?;~!)(B
	(min (string-to-int (substring st 14 16))) ; $B2?J,!)(B
	(sec (string-to-int (substring st 17 19)))); $B2?IC!)(B
    (+ sec (* 60 min) (* 3600 hr))))


(defun TRR:lap-time ()
  (if TRR:emacs19
      (let ((c (current-time)))
	(+ (* (car c) 65536.0)
	   (nth 1 c)
	   (/ (nth 2 c) 1000000.0)))
    (TRR:convert-time-string-to-second (current-time-string))))


(defun TRR:normalize-text ()
  (goto-char (point-min))
  (replace-string "\t" " ")
  (goto-char (point-min))
  (while (re-search-forward "^ +" nil t) (replace-match ""))
  (goto-char (point-min))
  (while (re-search-forward "   +" nil t) (replace-match "  "))
  (goto-char (point-min))
  (while (re-search-forward "\n\n+" nil t) (replace-match "\n"))
  (goto-char (point-min))
  (fill-paragraph nil))


(defun TRR:read-file (filename)
  (save-excursion
    (set-buffer (get-file-buffer TRR:text-file))
    (if TRR:random-flag
	(goto-line (TRR:random-num))
      (goto-line
	 (* TRR:steps (/ TRR:number-of-text-lines 64))))
    (let (fill-column text start)
      (skip-chars-forward "^!.?")
      (forward-char)
      (skip-chars-forward "\n \"")
      (setq start (point))
      (forward-line TRR:contents-text-read-lines)
      (setq text (buffer-substring start (point)))
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (setq fill-column (- (window-width) 5))
      (erase-buffer)
      (insert text)
      (TRR:normalize-text)
      (fill-region (point-min) (point-max))
      (goto-char (point-min))
      (replace-string "\n" "\r\n\n\n")
      (goto-char (point-min)))))


(defun TRR:initiate-variables ()
  (setq TRR:total-times 0)
  (setq TRR:total-time  0)
  (setq TRR:times-of-current-step 0)
  (setq TRR:time-of-current-step  0)
  (setq TRR:whole-chars-of-current-step 0)
  (setq TRR:whole-miss-of-current-step 0)
  (get-file-buffer TRR:text-file)
  (set-buffer (get-file-buffer TRR:text-file))
  (setq TRR:number-of-text-lines (- (count-lines (point-min) (point-max))
				    TRR:contents-text-read-lines))
  (set-buffer (get-buffer-create TRR:display-buffer))
  (erase-buffer)
  (TRR:read-file TRR:text-file)
  (setq TRR:high-score (TRR:get-hich-score))
  (setq TRR:high-score-old TRR:high-score)
  (setq TRR:beginner-flag (< TRR:high-score-old 0))
  (set-buffer (get-buffer-create TRR:record-buffer))
  (setq TRR:steps (1- (count-lines (point-min) (point-max))))
  (goto-char (point-min))
  (while (not (eobp))
    (setq TRR:times-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 4) (+ (point) 8))))
    (setq TRR:total-times
	  (+ TRR:total-times TRR:times-of-current-step))
    (setq TRR:time-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 9) (+ (point) 15))))
    (setq TRR:total-time
	  (+ TRR:total-time TRR:time-of-current-step))
    (setq TRR:whole-chars-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 16) (+ (point) 22))))
    (setq TRR:whole-miss-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 23) (+ (point) 28))))
    (forward-line)))


(defun TRR:write-graph (data-list skip string)
  (erase-buffer)
  (insert string "\n")
  (let ((fill-column (window-width)))
    (center-region (point-min) (point)))
  (let ((max 0)
	(min 10000)
	(rest data-list)
	(revlist nil)
	(steps 0)
	(move-count 0)
	temp graph-steps horizontal-steps scale-x scale-y)
    (if (not rest) t
      (setq steps (1+ steps))
      (setq temp (car rest))
      (setq rest (cdr rest))
      (setq max (max max temp))
      (if (/= temp 0) 
	  (setq min (min min temp)))
      (setq revlist (cons temp revlist)))
    (while rest
      (setq steps (1+ steps))
      (setq temp (car rest))
      (setq rest (cdr rest))
      (setq max (max max temp))
      (setq min (min min temp))
      (setq revlist (cons temp revlist)))
    (setq graph-steps (/ (- (window-height) 5) 2)       ; $B=DL\@9$j$N?t!)(B
	  horizontal-steps (/ (- (window-width) 8) 4)   ; $B2#L\@9$j$N?t!)(B
	  scale-x (let ((i horizontal-steps))
		    (while (< i steps)
		      (setq i (* i 2)))
		    (/ i horizontal-steps))
	  fill-column (- (window-width) 4))
    (let ((diff (- steps (* horizontal-steps 2))))
      (if (> diff 0)
	  (progn 
	    (while (> diff 0)
	      (setq revlist (cdr revlist))
	      (setq move-count (1+ move-count))
	      (setq diff (1- diff)))
	    (setq steps (* horizontal-steps 2))
	    (setq scale-x 2)
	    (setq rest revlist)
	    (setq max 0)
	    (setq min 10000)
	    (while rest
	      (setq max (max max (car rest)))
	      (if (or (cdr rest) (/= 0 (car rest)))
		  (setq min (min min (car rest))))
	      (setq rest (cdr rest))))))
    (if (> min max) (setq min 0)
      (setq min (- min (% min 10))))
    (setq scale-y (max 1 
		       (if (= (% (- max min) graph-steps) 0)
			   (/ (- max min) graph-steps)
			 (1+ (/ (- max min) graph-steps)))))
;; 1 2 3 4 5 6 8 10 12 15 20 25 30 40 50 60 70 80 90 100 120 140 160 180 200..
    (cond ((> scale-y 100)                                 ;; 20 $B$G$^$k$a$k(B
	   (if (zerop (% scale-y 20))
	       (setq scale-y (* (/ scale-y 20) 20))
	     (setq scale-y (+ (* (/ scale-y 20) 20) 20))))
	  ((> scale-y 30)                                  ;; 10 $B$G$^$k$a$k(B
	   (if (zerop (% scale-y 10))
	       (setq scale-y (* (/ scale-y 10) 10))
	     (setq scale-y (+ (* (/ scale-y 10) 10) 10))))
	  ((> scale-y 13)                                  ;;  5 $B$G$^$k$a$k(B
	   (if (zerop (% scale-y 5))
	       (setq scale-y (* (/ scale-y 5) 5))
	     (setq scale-y (+ (* (/ scale-y 5) 5) 5))))
	  ((> scale-y 6)                                   ;;  2 $B$G$^$k$a$k(B
	   (if (zerop (% scale-y 2))
	       (setq scale-y (* (/ scale-y 2) 2))
	     (setq scale-y (+ (* (/ scale-y 2) 2) 2)))))
    (if (< graph-steps 2)
	t
      (let ((i graph-steps))
	(while (> i 0)
	  (insert "     $B(-(B\n" (format "%4d" (+ min (* i scale-y)))
		  " $B(2(B\n")
	  (setq i (1- i)))
	(insert "     $B(-(B\n" (format "%4d" min) " $B(1(B")
	(while (< i horizontal-steps)
	  (insert "$B(,(5(B")
	  (setq i (1+ i)))
	(insert (format "\n   %4d" move-count))
	(setq i 1)
	(while (<= i horizontal-steps)
	  (insert (format "%4d" (+ 
				 (* i scale-x)
				 skip
				 move-count)))
	  (setq i (1+ i))))
      (goto-char (point-max))
      (beginning-of-line)
      (forward-char 5)
      (let ((times (max 1 (/ 4 scale-x)))
	    (inter (max 1 (/ scale-x 4)))
	    (templist revlist)
	    (i 1)
	    data height)
	(save-excursion
	  (while templist
	    (setq data (car templist))
	    (setq templist (cdr templist))
	      (let ((th (/ (* (- data min) 4) scale-y)))
		(setq height (+ (/ th 2) (% th 2))))
	      (forward-char times)
	      (save-excursion
		(TRR:move-up (1+ height))
		(if (and (= i 1) (= times 1))
		    (progn
		      (delete-char 1)
		      (insert " ")))
		(if (zerop height)
		    (if (or (/= data 0) templist)
			(progn (delete-char 2)
			       (insert "$B!z(B")))
		  (insert "$B!z(B")))
	      (setq i (1+ i))))))))


(defun TRR:random-num ()
  (let (num
	(num1 (random))
	(num2 (random t)))
    (if (> num1 0) t
      (setq num1 (- num1)))
    (if (> num2 0) t
      (setq num2 (- num2)))
    (setq num (+ (/ num1 2) (/ num2 2)))
    (% num TRR:number-of-text-lines)))


(defun TRR:update-score-file (score)
  (call-process TRR:update-program nil 0 nil
		TRR:directory
		"TanakaMaririnGanbarimasu"
		TRR:score-file
		(user-login-name)
		(int-to-string score) 
		(int-to-string TRR:steps)
		(int-to-string TRR:total-times)
		(int-to-string (/ TRR:total-time 60))))


(defun TRR:get-hich-score ()
  (set-buffer (get-file-buffer TRR:score-file))
  (goto-char (point-min))
  (while (and 
	  (not (eobp))
	  (not (looking-at (format "%s\t" (user-login-name)))))
    (forward-line 1))
  (if (eobp)
      -1
    (let (beg)
      (while (not (looking-at "\t"))
	(forward-char 1))
      (while (looking-at "\t")
	(forward-char 1))
      (setq beg (point))
      (while (not (looking-at "\t"))
	(forward-char 1))
      (string-to-int (buffer-substring beg (point))))))


(defun TRR:show-ranking ()
  (switch-to-buffer (get-buffer-create TRR:display-buffer))
  (erase-buffer)
  (insert "$B=g0L(B  $B%m%0%$%sL>(B\t$B%9%3%"(B\tstep\t$BAm2s?t(B\t$BAm;~4V(B\t  $BF|IU(B,   $B;~4V(B\n")
  (save-excursion (insert-file TRR:score-file))
  (let ((i 1)
	(self nil)
	(uname (user-login-name)))
    (while (not (eobp))
      (insert (format "%3d   " i))
      (if (looking-at (format "\\(%s\\)\t" uname))
	  (progn
	    (replace-match "")
	    (insert (format "%-10s\t" (concat ">" uname "<")))
	    (setq self (match-beginning 1)))
	(skip-chars-forward "^\t\n")
	(if (looking-at "\t")
	    (insert "\t")))
      (forward-line 1)
      (setq i (1+ i)))
    (if self
	(goto-char self)
      (goto-char (point-min))))
  (switch-to-buffer TRR:display-buffer))


(defun TRR:get-graph-points ()
  (setq TRR:skipped-step 0)
  (setq TRR:list-of-speed nil)
  (setq TRR:list-of-miss nil)
  (setq TRR:list-of-time nil)
  (setq TRR:list-of-times nil)
  (setq TRR:list-of-value nil)
  (setq TRR:list-of-average nil)
  (save-excursion
    (set-buffer (get-buffer-create TRR:record-buffer))
    (goto-char (point-min))
    (let ((curstep 1)
	  (curpoint (point))
	  curtime wc mc)
      (while (not (eobp))
	(setq wc (string-to-int 
		  (buffer-substring 
		   (+ curpoint 16) (+ curpoint 22))))
	(setq mc (string-to-int 
		  (buffer-substring 
		   (+ curpoint 23) (+ curpoint 28))))
	(setq curtime (string-to-int 
		       (buffer-substring 
			(+ curpoint 9) (+ curpoint 15))))
	(if (zerop curtime)
	    (setq TRR:skipped-step (1+ TRR:skipped-step))
	  (setq TRR:list-of-value
		(cons 
		 (string-to-int
		  (buffer-substring 
		   curpoint (+ curpoint 3)))
		 TRR:list-of-value))
	  (setq TRR:list-of-times
		(cons 
		 (string-to-int
		  (buffer-substring 
		   (+ curpoint 4) (+ curpoint 8)))
		 TRR:list-of-times))
	  (setq TRR:list-of-time
		(cons 
		 (/ curtime 60)
		 TRR:list-of-time))
	  (setq TRR:list-of-speed
		(cons 
		 (if (zerop curtime) 0 (/ (* wc 60) curtime))
		 TRR:list-of-speed))
	  (setq TRR:list-of-miss
		(cons 
		 (if (zerop wc) 0 (/ (* mc 1000) wc))
		 TRR:list-of-miss))
	  (setq TRR:list-of-average
		(cons 
		 (TRR:evaluate-point wc mc curtime)
		 TRR:list-of-average)))
 	(forward-line)
	(setq curpoint (point))
	(setq curstep (+ curstep 1))))))


(defun TRR:get-date ()
  (if (not TRR:pass-flag) "$B$U$!$$$H(B!"
    (let ((in-string (current-time-string))
	  (out-string nil))
      (setq out-string (concat out-string (substring in-string 22 24)))
      (setq out-string (concat out-string "/"))
      (setq out-string (concat out-string (substring in-string 4 7)))
      (setq out-string (concat out-string "/"))
      ;; date 1-9 to 01-09
      (setq out-string
	    (concat out-string 
		    (format "%02d"
			    (string-to-int (substring in-string 8 10))))))))


(setq TRR:demo-string 
'("####### ######  ###### "
  "   #    #     # #     #"
  "   #    #     # #     #"
  "   #    ######  ###### "
  "   #    #   #   #   #  "
  "   #    #    #  #    # "
  "   #    #     # #     #"))
(defun TRR:demo ()
  (interactive)
  (let ((win-width  (- (window-width) 3))
	(win-height (window-height))
	(str-width  (length (car TRR:demo-string)))
	(str-height (length TRR:demo-string))
	start-point i j k evenp sline c)
    (erase-buffer)
    (insert-char ?\n win-width)
    (goto-line (/ (- win-height str-height) 2))

    (if (= (% (- win-width str-width) 2) 1)
	(setq win-width (1- win-width)))

    (setq start-point (point)
	  i 0
	  evenp nil)
    (while (< i str-height)
      (if evenp (insert-char ?\  win-width))
      (forward-line 1)
      (setq evenp (not evenp)
	    i (1+ i)))

    (setq j 0)
    (while (< j str-width)
      (goto-char start-point)
      (setq evenp nil
	    i 0
	    sline TRR:demo-string)
      (while (< i str-height)
	(if evenp
	    (progn
	      (delete-char 1)
	      (end-of-line)
	      (insert-char (aref (car sline) j) 1))
	  (insert-char (aref (car sline) (- str-width j 1)) 1))
	(setq i (1+ i)
	      evenp (not evenp)
	      sline (cdr sline))
	(forward-line 1))
      (setq j (1+ j))
      (sit-for 0))
    (setq j 0
	  k (/ (- win-width str-width) 2))
    (while (< j k)
      (goto-char start-point)
      (setq evenp nil
	    i 0
	    sline TRR:demo-string)
      (while (< i str-height)
	(if evenp
	    (delete-char 1)
	  (insert-char ?\  1))
	(setq i (1+ i)
	      evenp (not evenp)
	      sline (cdr sline))
	(forward-line 1))
      (setq j (1+ j))
      (sit-for 0))))


;;
;; face overlay (It works on emacs 19 or after)
;;
(defun TRR:new-overlay (pos)
  (if (and TRR:trainer-type-face TRR:emacs19 (/= pos (1+ (buffer-size))))
      ((lambda (ovr)
	 (setq TRR:overlay-list (cons ovr TRR:overlay-list))
	 (overlay-put ovr 'face TRR:trainer-type-face))
       (make-overlay pos pos))))

(defun TRR:move-overlay (text-pos)
  (if (and TRR:trainer-type-face TRR:emacs19)
      ((lambda (ovr)
	 (move-overlay ovr (overlay-start ovr) text-pos))
       (car TRR:overlay-list))))

(defun TRR:delete-overlay ()
  (if (and TRR:trainer-type-face TRR:emacs19)
      (progn
	(mapcar (function delete-overlay) TRR:overlay-list)
	(setq TRR:overlay-list nil))))

(defun TRR:mark-miss-type-position (&optional pos)
  (if (and TRR:trainer-type-face TRR:emacs19)
      (let* (ovr)
	(or pos
	    (setq pos (point)))
	(setq ovr (make-overlay pos (1+ pos)))
	(setq TRR:miss-type-face-overlays
	      (cons ovr TRR:miss-type-face-overlays))
	(overlay-put ovr 'face TRR:miss-type-face))))
